from habitmove.nomie_parser import NomieParser
import json
import pytest


@pytest.fixture
def sample_data():
    return '{ "nomie": { "number": "5.6.4", "created": "2021-08-26T08:15:36.898Z", "startDate": "2021-08-26T08:15:36.898Z", "endDate": "2021-08-26T08:15:36.898Z" }}'


def test_nomie_parser_exists():
    sut = NomieParser()
    assert type(sut) == NomieParser


def test_nomie_parser_errors_on_invalid_data():
    with pytest.raises(json.decoder.JSONDecodeError):
        NomieParser(data="invalid_test_data")


def test_nomie_parser_saves_data():
    sut = NomieParser(data='{"test": "entry"}')
    assert sut.data == {"test": "entry"}


def test_nomie_parser_extracts_version(sample_data):
    sut = NomieParser(data=sample_data)
    assert sut.extract_version() == "5.6.4"
